classdef Current<handle
    %CURRENT Summary of this class goes here
    %   Detailed explanation goes here
    
    properties
        Im
        Iexp
        w
        phi
        Tp
    end
    
    methods
        function val=i(this,t)
            val=Current.Get_i(t, this.Im, this.Iexp, this.w, this.phi, this.Tp);
        end
        
       function val=di(this,t)
            val=Current.Get_di(t, this.Im, this.Iexp, this.w, this.phi, this.Tp);
       end
        
       function this=Current(Im,Iexp,w,phi,Tp)
           this.Im=Im;
           this.Iexp=Iexp;
           this.w=w;
           this.phi=phi;
           this.Tp=Tp;           
       end
       
    end
    
    
    methods (Static)
        function val=Get_i(t, Im, Iexp, w, phi, Tp)
            if Tp~=0
                val=Im*sin(w*t+phi)+Iexp*exp(-t/Tp);
            else
                val=Im*sin(w*t+phi);
            end
        end
        
        function val=Get_di(t, Im, Iexp, w, phi, Tp)
            if Tp~=0
                val=w*Im*cos(w*t+phi)-Iexp/Tp*exp(-t/Tp);
            else
                val=w*Im*cos(w*t+phi);
            end
        end
    end
    
end

